function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useCallback, useEffect } from 'react';
import { useAlertsContext } from './AlertsContextProvider';
const Alert = ({
  alert,
  ...args
}) => {
  const {
    message,
    type,
    display
  } = alert;
  const {
    removeAlert
  } = useAlertsContext();
  useEffect(() => {
    setTimeout(() => hideAlert(), 3000);
  }, []);
  const hideAlert = useCallback(() => {
    removeAlert(alert);
  }, [alert]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", _extends({
    className: `spaced-inline flex align-center custom-alert alert alert-${type} ${display != '' ? '' : 'hidden'}`
  }, args), /*#__PURE__*/React.createElement("span", null, message)));
};
export default Alert;