import React, { useCallback, useContext, useState } from 'react';
import Alerts from './Alerts';
const AlertsContextProvider = ({
  children,
  ...args
}) => {
  const [alertsContext, setAlertsContext] = useState([]);
  const addAlert = useCallback((message, type) => setAlertsContext(prev => [...prev, {
    message,
    type,
    display: true
  }]), []);
  const removeAlert = alert => {
    new Promise(resolve => {
      setAlertsContext(prev => {
        const index = prev.findIndex(a => a === alert);
        prev[index].display = false;
        return [...prev];
      });
      setTimeout(() => {
        resolve(true);
      }, 1500);
    }).then(() => {
      setAlertsContext(prev => {
        const index = prev.findIndex(a => a === alert);
        prev.splice(index, 1);
        return [...prev];
      });
    });
  };

  // useEffect(() => {
  //   if (alertsContext.length > 0 && alertsContext.every((a) => !a.display)) {
  //     setAlertsContext([])
  //   }
  // }, [alertsContext])

  return /*#__PURE__*/React.createElement(AlertContext.Provider, {
    value: {
      alerts: alertsContext,
      setAlertsContext,
      addAlert,
      removeAlert
    }
  }, /*#__PURE__*/React.createElement(Alerts, args), children);
};
export default AlertsContextProvider;
const AlertContext = /*#__PURE__*/React.createContext({
  alerts: []
});
export const useAlertsContext = () => useContext(AlertContext);