function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useMemo } from 'react';
import { DragDropContext, Draggable, Droppable } from 'react-beautiful-dnd';
const DnDList = ({
  items,
  setItems,
  templateItem = () => {},
  ...props
}) => {
  const itemsFormatted = useMemo(() => {
    items.forEach(i => {
      if (i.id == null) {
        i.id = Date.now() * Math.random();
      }
    });
    return items;
  }, [items]);
  const onDragEnd = ({
    source,
    destination
  }) => {
    if (destination != null) {
      const copy = [...items];
      const item = copy.splice(source.index, 1)[0];
      copy.splice(destination.index, 0, item);
      setItems(copy);
    }
  };
  return /*#__PURE__*/React.createElement(DragDropContext, {
    onDragEnd: onDragEnd
  }, /*#__PURE__*/React.createElement(Droppable, {
    droppableId: "drop-area"
  }, provided => /*#__PURE__*/React.createElement("div", _extends({
    ref: provided.innerRef
  }, provided.droppableProps, props), itemsFormatted.map((item, index) => /*#__PURE__*/React.createElement(Draggable, {
    draggableId: item.id.toString(),
    index: index,
    key: item.id
  }, providedDra => /*#__PURE__*/React.createElement("div", _extends({
    ref: providedDra.innerRef
  }, providedDra.draggableProps, providedDra.dragHandleProps), templateItem(item, index)))), provided.placeholder)));
};
export default DnDList;