import React from 'react';
import CustomFormField from './CustomFormField';
import SubTitle from './SubTitle';
const ListFormControl = ({
  label = '',
  list = [],
  setList = () => {},
  titleActions = [],
  fields = [],
  titleClass = '',
  canSwitch = false
}) => {
  const remove = index => {
    const copy = [...list];
    copy.splice(index, 1);
    setList(copy);
  };
  const update = (index, propName, value) => {
    const copy = [...list];
    copy[index][propName] = value;
    setList(copy);
  };
  const getFieldLabel = field => {
    const label = field.label;
    return label != null ? label.charAt(0).toUpperCase() + label.slice(1) : label;
  };
  const isLast = indexItem => indexItem === list.length - 1;
  const switchItems = index => {
    const copy = [...list];
    copy[index] = copy.splice(index + 1, 1, copy[index])[0];
    setList(copy);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "list-form-control"
  }, /*#__PURE__*/React.createElement(SubTitle, {
    className: titleClass,
    actions: titleActions
  }, label), list.map((item, indexItem) => /*#__PURE__*/React.createElement(React.Fragment, {
    key: indexItem
  }, /*#__PURE__*/React.createElement("div", {
    className: "form-line align-end"
  }, fields.map((f, indexField) => /*#__PURE__*/React.createElement(CustomFormField, {
    key: `${indexField}_${indexItem}`,
    placeholder: f.placeholder,
    label: getFieldLabel(f),
    value: item[f.propName],
    onChange: value => update(indexItem, f.propName, value),
    type: f.type == null ? 'text' : f.type,
    isValid: !f.required || item[f.propName] != '',
    options: f.options ?? []
  })), /*#__PURE__*/React.createElement("button", {
    type: "button",
    className: "btn btn-danger delete-button",
    onClick: () => remove(indexItem)
  }, /*#__PURE__*/React.createElement("span", {
    className: "mdi mdi-delete mdi-36px"
  }))), canSwitch && !isLast(indexItem) && /*#__PURE__*/React.createElement("div", {
    className: "flex center niveau-switch-button-container"
  }, /*#__PURE__*/React.createElement("button", {
    className: "btn btn-primary",
    type: "button",
    onClick: e => switchItems(indexItem),
    title: "Echanger"
  }, /*#__PURE__*/React.createElement("span", {
    className: "mdi mdi-swap-vertical mdi-36px"
  }))))));
};
export default ListFormControl;