export const reactSelectStyle = (displayError, isValid) => ({
  theme: theme => {
    const style = getComputedStyle(document.body);
    return {
      ...theme,
      borderRadius: '1rem',
      spacing: {
        ...theme.spacing,
        controlHeight: 50
      },
      colors: {
        ...theme.colors,
        primary: style.getPropertyValue('--bs-primary'),
        secondary: style.getPropertyValue('--bs-secondary')
      }
    };
  },
  styles: {
    option: (styles, data) => {
      const isFirst = data.options[0].value === data.value;
      const isLast = data.options[data.options.length - 1].value === data.value;
      if (isFirst) {
        styles.borderTopLeftRadius = '1rem';
        styles.borderTopRightRadius = '1rem';
      }
      if (isLast) {
        styles.borderBottomLeftRadius = '1rem';
        styles.borderBottomRightRadius = '1rem';
      }
      return styles;
    },
    control: (styles, data) => {
      const style = getComputedStyle(document.body);
      if (displayError && !isValid && !data.isFocused) {
        styles.border = `1px solid ${style.getPropertyValue('--bs-orange')} !important`;
      }
      return styles;
    },
    multiValue: base => ({
      ...base,
      borderRadius: '0.25em'
    })
  }
});