import React, { useContext, useMemo, useState } from 'react';
import CustomModal from './CustomModal';
const Confirm = () => {
  const context = useContext(ConfirmContext);
  return /*#__PURE__*/React.createElement(CustomModal, {
    title: context.title,
    content: context.content,
    cancelLabel: "Annuler",
    validateLabel: context.validateLabel,
    show: context.show,
    onValidate: context.callback,
    setShow: () => context.setContext({
      ...context,
      show: false
    }),
    hideCancel: context.hideCancel
  });
};
export const ConfirmContext = /*#__PURE__*/React.createContext({
  title: '',
  content: '',
  show: false,
  callback: () => {},
  setContext: null,
  hideCancel: false,
  validateLabel: 'Confirmer'
});
export const initConfirm = () => {
  const [confirmOptions, setConfirmOptions] = useState({
    title: 'Confirmation',
    content: '',
    callback: () => {},
    show: false,
    hideCancel: false,
    validateLabel: 'Confirmer'
  });
  const contextValue = useMemo(() => ({
    ...confirmOptions,
    setContext: setConfirmOptions
  }), [confirmOptions]);
  return contextValue;
};
export const useConfirm = () => {
  const confirmContext = useContext(ConfirmContext);
  const confirm = (content, callback, title = 'Confirmation', hideCancel = false, validateLabel = 'Confirmer') => confirmContext.setContext({
    title,
    content,
    callback,
    show: true,
    hideCancel,
    validateLabel
  });
  return confirm;
};
export default Confirm;